#debug "Shot five is being parsed.\n"

#include "gulch.inc"

#declare PortX=-x;
#declare PortY=y;
#declare PortZ=-z;
#declare PortL=<0,0,1400>;
#declare PortOpen=1;
#include "port.inc"

#local i_I=804.6;

#declare RobotY=y;
#declare RobotZ=-z;
#declare RobotX=-x;
#declare RobotL=<50,0,-500>;
#declare RotLT=i_I*180/pi/5.625/sqrt(2+sqrt(3));
#declare RotRT=i_I*180/pi/5.625/sqrt(2+sqrt(3));
#declare CamLft1=0;
#declare CamSwp1=0;
#declare CamLft2=15;
#declare CamSwp2=0;
#declare CamLft3=15;
#declare CamSwp3=-180;
#declare BotHandDir=z;
#declare BotHandLoc=<0,100,25>;
#declare ClawOpen=5;
#declare PortClip=false;
#include "rusty.inc"

#local i_I=0;

#declare BoxerZ=-z;
#declare BoxerY=y;
#declare BoxerX=-x;
#declare BoxerL=<-50,0,-500>;
#declare BoxerEyeL=<0,150,2000>;
#declare BoxerEyeR=<0,150,2000>;
#declare BoxerHandL=<-15,40,45>;
#declare BoxerHandR=< 15,40,45>;
#declare BoxerWristL=0;
#declare BoxerWristR=0;
#declare BoxerClawL=15;
#declare BoxerClawR=15;
#declare FootL=<-14,0,21>;
#declare FootR=< 14,0, 8>;
#declare WheelSpin=i_I*360/2/pi/10;
#declare WheelTurn=0;
#declare GateClip=false;
#declare DoorOpen=1;
#declare LaserUp=1;
#declare LaserOn=0;
#if (Timer>1.999) #declare LaserOn=1; #end
#if (Timer>2.499) #declare LaserOn=0; #end
#declare Target=<-50,100,481>;
#include "boxer.inc"

#declare Hands=array[4] { 0,0,0,0 }

SmoothSeed(Hands,2)

#local i_I=0; #while (i_I<7)

#switch(i_I)
  #case(0)
//#debug "First bug.\n"
    #declare pGreb=<0,0,-500>-vnormalize(<-2,0,-3>)*280;
    #declare vGreb=vnormalize(<-2,0,-3>);
    #declare Skin0=.5;
    #declare Skin1=.5;
  #break
  #case(1)
//#debug "Second bug.\n"
    #declare pGreb=<0,0,-500>-vnormalize(< 0,0,-1>)*280;
    #declare vGreb=vnormalize(< 0,0,-1>);
    #declare Skin0=.25;
    #declare Skin1=.25;
  #break
  #case(2)
//#debug "Third bug.\n"
    #declare pGreb=<0,0,-500>-vnormalize(<-2,0,-1>)*280;
    #declare vGreb=vnormalize(<-2,0,-1>);
    #declare Skin0=.75;
    #declare Skin1=.75;
  #break
  #case(3)
//#debug "Fourth bug.\n"
    #declare pGreb=<0,0,-500>-vnormalize(<-4,0, 1>)*280;
    #declare vGreb=vnormalize(<-4,0, 1>);
    #declare Skin0=.125;
    #declare Skin1=.125;
  #break
  #case(4)
//#debug "Fifth bug.\n"
    #declare pGreb=<0,0,-500>-vnormalize(< 5,0,-2>)*280;
    #declare vGreb=vnormalize(< 5,0,-2>);
    #declare Skin0=.375;
    #declare Skin1=.375;
  #break
  #case(5)
//#debug "Sixth bug.\n"
    #declare pGreb=<0,0,-500>-vnormalize(< 4,0, 1>)*280;
    #declare vGreb=vnormalize(< 4,0, 1>);
    #declare Skin0=.625;
    #declare Skin1=.625;
  #break
  #case(6)
//#debug "Seventh bug.\n"
    #declare pGreb=<0,0,-500>-vnormalize(< 4,0,-5>)*280;
    #declare vGreb=vnormalize(< 4,0,-5>);
    #declare Skin0=.875;
    #declare Skin1=.875;
  #break
#end

#declare GrebGaze=<0,75,-500>;
#declare FingerL=<-16,26,51>
  +<SmoothRand(Hands),SmoothRand(Hands),SmoothRand(Hands)>*<-8,19,21>;
#declare FingerR=< 16,26,51>
  +<SmoothRand(Hands),SmoothRand(Hands),SmoothRand(Hands)>*< 8,19,21>;

#declare BodyRise=
  <SmoothRand(Hands)-.5,SmoothRand(Hands),SmoothRand(Hands)-.5>*<5,10,5>;

#local xGreb=vnormalize(vcross(y,vGreb));

#declare FootLH=pGreb-52.9*xGreb-40*vGreb;
#declare LiftLH=0*y;
#declare FootRH=pGreb+52.9*xGreb-40*vGreb;
#declare LiftRH=0*y;
#declare FootLF=pGreb-52.9*xGreb+40*vGreb;
#declare LiftLF=0*y;
#declare FootRF=pGreb+52.9*xGreb+40*vGreb;
#declare LiftRF=0*y;

#include "greb.inc"

#local i_I=i_I+1; #end

#declare FingerL=Transition(<-16,55,71>,<-16,26,51>,0*y,Timer-.75)+
  <SmoothRand(Hands)-.5,SmoothRand(Hands),SmoothRand(Hands)-.5>*<1,2,1>;
#declare FingerR=< 16,26,51>+
  <SmoothRand(Hands)-.5,SmoothRand(Hands),SmoothRand(Hands)-.5>*<1,2,1>;
#declare BodyRise=10*y+(<SmoothRand(Hands),SmoothRand(Hands),SmoothRand(Hands)>-.5);

#declare FootLH=<-52.9,0,-40>+<0,40,-1000>;
#declare LiftLH=y*0;
#declare FootRH=< 52.9,0,-40>+<0,40,-1000>;
#declare LiftRH=y*0;
#declare FootLF=<-56.4,0, 40>+<0,40,-1000>;
#declare LiftLF=y*0;
#declare FootRF=< 56.4,0, 40>+<0,40,-1000>;
#declare LiftRF=y*0;
#declare Skin0=0;
#declare Skin1=0;
#declare GrebGaze=Transition(<50,75,-500>,<-50,75,-500>,y*10,Timer-.5);
#declare BugLife=min(max(3-Timer,0),1);

#include "greb.inc"

#declare CamE=<0,115,-981>;
#declare CamL=CamE+vnormalize(<1,0,2>)*(153+Timer*7);
