#local BustIron=texture {
  pigment {rgb .75}
  finish {specular .25 roughness .1 }
  normal { crackle 1 scale .3 }
  translate 100*rand(Seed)
}

#local BustBrass=texture {
  pigment { rgb <.75,.65,.55>}
  finish { specular .25 roughness .1 }
  normal { crackle 1 scale .3 }
  translate 100*rand(Seed)
}

//corners of bugbot:

#local UC0=< .11,0, .47>;
#local UC1=< .27,0, .17>;
#local UC2=< .27,0,-.17>;
#local UC3=< .11,0,-.47>;
#local UC4=<-.11,0,-.47>;
#local UC5=<-.27,0,-.17>;
#local UC6=<-.27,0, .17>;
#local UC7=<-.11,0, .47>;

#local BEL=<-.06, 0 , .50>;
#local BER=< .06, 0 , .50>;
#local ABL=<-.11,.03, .42>;
#local ABR=< .11,.03, .42>;
#local ATL=<-.28,.01, .53>;
#local ATR=< .28,.01, .53>;

union {
  prism { 0,.03,9,< .11, .47>,< .27, .17>,< .27,-.17>,< .11,-.47>,
    <-.11,-.47>,<-.27,-.17>,<-.27, .17>,<-.11, .47>,< .11, .47>
    texture { BustIron } }

  cylinder { UC0,UC1,.03 texture { BustIron } }
  cylinder { UC1,UC2,.03 texture { BustIron } }
  cylinder { UC2,UC3,.03 texture { BustIron } }
  cylinder { UC3,UC4,.03 texture { BustIron } }
  cylinder { UC4,UC5,.03 texture { BustIron } }
  cylinder { UC5,UC6,.03 texture { BustIron } }
  cylinder { UC6,UC7,.03 texture { BustIron } }
  cylinder { UC7,UC0,.03 texture { BustIron } }

  sphere { UC0,.03 texture { BustIron } }
  sphere { UC1,.03 texture { BustIron } }
  sphere { UC2,.03 texture { BustIron } }
  sphere { UC3,.03 texture { BustIron } }
  sphere { UC4,.03 texture { BustIron } }
  sphere { UC5,.03 texture { BustIron } }
  sphere { UC6,.03 texture { BustIron } }
  sphere { UC7,.03 texture { BustIron } }

  sphere { BEL,.04 texture { BugEye } }
  sphere { BER,.04 texture { BugEye } }

  sphere { ABL,.01 texture { BustIron } }
  sphere { ABR,.01 texture { BustIron } }
  cylinder { ABL,ATL,.01 texture { BustIron } }
  cylinder { ABR,ATR,.01 texture { BustIron } }
  sphere { ATL,.02 texture { BustIron } }
  sphere { ATR,.02 texture { BustIron } }

#if(SparkOn=true)
sphere { ATL,(clock*6-floor(clock*6))*.10+.021 no_shadow texture { BugSpark } }
sphere { ATR,(clock*6-floor(clock*6))*.10+.021 no_shadow texture { BugSpark } }
#end

#local s_1=sqrt(.5*.5+.26*.26);
#local s_2=s_1/sqrt(13); // thigh length
#local s_3=s_1*2/sqrt(13); // shin length
#local L=<-15,0,8>/17;
#local R=< 15,0,8>/17;

#local Count=0; #while (Count<6)

#switch (Count)

#case (0)
#local Hip=<-.19,0, .32>+.03*L;
#local Knee=Hip+vrotate(L*s_2,y*10*(rand(Seed)-rand(Seed)));
#local Foot=Knee+vrotate(L*s_3,y*30*(rand(Seed)-rand(Seed)));
#break

#case (1)
#local Hip=< .19,0, .32>+.03*R;
#local Knee=Hip+vrotate(R*s_2,y*10*(rand(Seed)-rand(Seed)));
#local Foot=Knee+vrotate(R*s_3,y*30*(rand(Seed)-rand(Seed)));
#break

#case (2)
#local Hip=<-.30,0,0>;
#local Knee=Hip-vrotate(x*s_2,y*10*(rand(Seed)-rand(Seed)));
#local Foot=Knee-vrotate(x*s_3,y*30*(rand(Seed)-rand(Seed)));
#break

#case (3)
#local Hip=< .30,0,0>;
#local Knee=Hip+vrotate(x*s_2,y*10*(rand(Seed)-rand(Seed)));
#local Foot=Knee+vrotate(x*s_3,y*30*(rand(Seed)-rand(Seed)));
#break

#case (4)
#local Hip=<-.19,0,-.32>-.03*R;
#local Knee=Hip-vrotate(R*s_2,y*10*(rand(Seed)-rand(Seed)));
#local Foot=Knee-vrotate(R*s_3,y*30*(rand(Seed)-rand(Seed)));
#break

#case (5)
#local Hip=< .19,0,-.32>-.03*L;
#local Knee=Hip-vrotate(L*s_2,y*10*(rand(Seed)-rand(Seed)));
#local Foot=Knee-vrotate(L*s_3,y*30*(rand(Seed)-rand(Seed)));
#break
#end

object { Connect(Knee,.04,Foot,.01) texture { BustBrass } }
sphere { Foot,.01 texture { BustBrass } }
sphere { Knee,.05 texture { BustBrass } }
cylinder { Hip,Knee,.04 texture { BustBrass } }
sphere { Hip,.06 texture { BustBrass } }

#local Count=Count+1; #end

  rotate y*20*(rand(Seed)-rand(Seed))
  Matrix(BugX,BugY,BugZ,BugL)
}
