#ifndef(GrebArm)

#local C=(sqrt(2)-1)*4/3;
#local C0=<1,1,0>;
#local C1=<1,1,C>;
#local C2=<C,C,1>;
#local C3=<0,0,1>;
#local S=3-Test;

#local A12=vnormalize(x-2*y);
#local A21=vnormalize(2*x-y);
#local A41=vnormalize(4*x+y);

#local P0=< 0,0,0>-A21*2;
#local P1=< 0,0,0>-A21*2*C;
#local P2=< 0,0,0>;
#local P3=< 0,0,0>+A21*3;
#local P4=<10,0,0>-A41*6;
#local P5=<10,0,0>;
#local P6=<10,0,0>+A41*6;
#local P7=<20,0,0>-A12*4;
#local P8=<20,0,0>;
#local P9=<20,0,0>+A12*2/3;

#local R0=<.01,.01,.01>;
#local R1=<2/sqrt(5),4/sqrt(5),2>*C;
#local R2=<2/sqrt(5),4/sqrt(5),2>;
#local R3=<-2/sqrt(17),8/sqrt(17),1.5>;
#local R4=<4/sqrt(5),2/sqrt(5),1>;
#local R5=<6/sqrt(5),3/sqrt(5),2>;

#declare GrebArm=mesh {

#local Count=0; #while (Count<4)
#switch (Count)
#case(0) #local Q=<-1,-1,-1>; #break
#case(1) #local Q=< 1, 1,-1>; #break
#case(2) #local Q=< 1, 1, 1>; #break
#case(3) #local Q=<-1,-1, 1>; #break
#end

Bicubic(
  P0+R0*C0*Q,P0+R0*C1*Q,P0+R0*C2*Q,P0+R0*C3*Q,
  P0+R1*C0*Q,P0+R1*C1*Q,P0+R1*C2*Q,P0+R1*C3*Q,
  P1+R2*C0*Q,P1+R2*C1*Q,P1+R2*C2*Q,P1+R2*C3*Q,
  P2+R2*C0*Q,P2+R2*C1*Q,P2+R2*C2*Q,P2+R2*C3*Q,S)

Bicubic(
  P2+R2*C0*Q,P2+R2*C1*Q,P2+R2*C2*Q,P2+R2*C3*Q,
  P3+R2*C0*Q,P3+R2*C1*Q,P3+R2*C2*Q,P3+R2*C3*Q,
  P4+R3*C0*Q,P4+R3*C1*Q,P4+R3*C2*Q,P4+R3*C3*Q,
  P5+R3*C0*Q,P5+R3*C1*Q,P5+R3*C2*Q,P5+R3*C3*Q,S)

Bicubic(
  P5+R3*C0*Q,P5+R3*C1*Q,P5+R3*C2*Q,P5+R3*C3*Q,
  P6+R3*C0*Q,P6+R3*C1*Q,P6+R3*C2*Q,P6+R3*C3*Q,
  P7+R5*C0*Q,P7+R5*C1*Q,P7+R5*C2*Q,P7+R5*C3*Q,
  P8+R5*C0*Q,P8+R5*C1*Q,P8+R5*C2*Q,P8+R5*C3*Q,S)

Bicubic(
  P8+R5*C0*Q,P8+R5*C1*Q,P8+R5*C2*Q,P8+R5*C3*Q,
  P9+R5*C0*Q,P9+R5*C1*Q,P9+R5*C2*Q,P9+R5*C3*Q,
  P9+R4*C0*Q,P9+R4*C1*Q,P9+R4*C2*Q,P9+R4*C3*Q,
  P8+R4*C0*Q,P8+R4*C1*Q,P8+R4*C2*Q,P8+R4*C3*Q,S)

#local Count=Count+1; #end
}

#declare l_GrebArm=20;
#end
